//+---------------------------------------------------------------------+
//|                                                      Starter EA.mq4 |
//|                                                           Eaglehawk |
//|                   "http://www.forex-tsd.com/members/Eaglehawk.html" |
//+---------------------------------------------------------------------+
#property copyright "Eaglehawk"
#property link      "http://www.forex-tsd.com/members/Eaglehawk.html"

extern int MagicNumber = 0;
extern bool SignalMail = False;
extern bool EachTickMode = False;
extern double Lots = 0.1;
extern int Slippage = 3;
extern bool StopLossMode = False;
extern int StopLoss = 5;
extern bool TakeProfitMode = True;
extern int TakeProfit = 30;
extern bool TrailingStopMode = True;
extern int TrailingStop = 15;
extern int MaxOpenTrade = 1;//maximum of trades open
extern bool UseDayOff = False;//safety feature i've developed that closes trades for the holidays interbankfx takes off

#define SIGNAL_NONE 0
#define SIGNAL_BUY   1
#define SIGNAL_SELL  2
#define SIGNAL_CLOSEBUY 3
#define SIGNAL_CLOSESELL 4

int BarCount;
int Current;
bool TickCheck = False;
bool DayOff = false;
bool DayOffClose = false;
//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init() {
   BarCount = Bars;

   if (EachTickMode) Current = 0; else Current = 1;

   return(0);
}
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit() {
   return(0);
}
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start() {

   int Order = SIGNAL_NONE;
   int Total, Ticket;
   double StopLossLevel, TakeProfitLevel;
   
   DayOff = False;
   DayOffClose = False;

   if (EachTickMode && Bars != BarCount) TickCheck = False;
   Total = OrdersTotal();
   Order = SIGNAL_NONE;

   //+------------------------------------------------------------------+
   //| Local Variable Input Begin                                       |
   //+------------------------------------------------------------------+


   //+------------------------------------------------------------------+
   //| Local Variable Input End                                         |
   //+------------------------------------------------------------------+

   //Check position
   bool IsTrade = False;

   for (int i = 0; i < Total; i ++) {
      OrderSelect(i, SELECT_BY_POS, MODE_TRADES);
      if(OrderType() <= OP_SELL &&  OrderSymbol() == Symbol()) {
         IsTrade = True; 
         if(OrderType() == OP_BUY) {
            //Close

            //+------------------------------------------------------------------+
            //| Exit Buy Begin                                                   |
            //+------------------------------------------------------------------+
               //runs the safety feature
               if (UseDayOff)
               {
               timedclosingtest(Order);
               }
               
            //+------------------------------------------------------------------+
            //| Exit Buy End                                                     |
            //+------------------------------------------------------------------+

            if (Order == SIGNAL_CLOSEBUY && ((EachTickMode && !TickCheck) || (!EachTickMode && (Bars != BarCount)))) {
               OrderClose(OrderTicket(), OrderLots(), Bid, Slippage, MediumSeaGreen);
               if (SignalMail) SendMail("[Signal Alert]", "[" + Symbol() + "] " + DoubleToStr(Bid, Digits) + " Close Buy");
               if (!EachTickMode) BarCount = Bars;
               IsTrade = False;
               continue;
            }
            //Trailing stop
            if(TrailingStopMode && TrailingStop > 0) {                 
               if(Bid - OrderOpenPrice() > Point * TrailingStop) {
                  if(OrderStopLoss() < Bid - Point * TrailingStop) {
                     OrderModify(OrderTicket(), OrderOpenPrice(), Bid - Point * TrailingStop, OrderTakeProfit(), 0, MediumSeaGreen);
                     if (!EachTickMode) BarCount = Bars;
                     TrailingStopMode = False; //resets mode after each order 
                     StopLossMode = False;  //resets mode after each order
                     continue;
                  }
               }
            }
         } else {
            //Close

            //+------------------------------------------------------------------+
            //| Exit Sell Begin                                                  |
            //+------------------------------------------------------------------+
               if (UseDayOff)
               {
               timedclosingtest(Order);
               }
               
            //+------------------------------------------------------------------+
            //| Exit Sell End                                                    |
            //+------------------------------------------------------------------+

            if (Order == SIGNAL_CLOSESELL && ((EachTickMode && !TickCheck) || (!EachTickMode && (Bars != BarCount)))) {
               OrderClose(OrderTicket(), OrderLots(), Ask, Slippage, DarkOrange);
               if (SignalMail) SendMail("[Signal Alert]", "[" + Symbol() + "] " + DoubleToStr(Ask, Digits) + " Close Sell");
               if (!EachTickMode) BarCount = Bars;
               IsTrade = False;
               continue;
            }
            //Trailing stop
            if(TrailingStopMode && TrailingStop > 0) {                 
               if((OrderOpenPrice() - Ask) > (Point * TrailingStop)) {
                  if((OrderStopLoss() > (Ask + Point * TrailingStop)) || (OrderStopLoss() == 0)) {
                     OrderModify(OrderTicket(), OrderOpenPrice(), Ask + Point * TrailingStop, OrderTakeProfit(), 0, DarkOrange);
                     if (!EachTickMode) BarCount = Bars;
                     TrailingStopMode = False; //resets mode after each order
                     StopLossMode = False; //resets mode after each order
                     continue;
                  }
               }
            }
         }
      }
   }

   //+------------------------------------------------------------------+
   //| Entry logics                                                     |
   //+------------------------------------------------------------------+
          {
          HolidayAbandonTest();
          HolidayTest();
          }
      if ((UseDayOff) && DayOff == False && DayOffClose == False)
      //put in your entry logics between theese brackets
      {
      
      }

   //+------------------------------------------------------------------+
   //| Signal End                                                       |
   //+------------------------------------------------------------------+

   //Buy 
   if (Order == SIGNAL_BUY && ((EachTickMode && !TickCheck) || (!EachTickMode && (Bars != BarCount)))) {
      IsTrade = False;//---allows multiple orders to open
      if(!IsTrade) {
         //Check free margin
         if (AccountFreeMargin() < (1000 * Lots)) {
            Print("We have no money. Free Margin = ", AccountFreeMargin());
            return(0);
         }

         if (StopLossMode) StopLossLevel = Ask - StopLoss * Point; else StopLossLevel = 0.0;
         if (TakeProfitMode) TakeProfitLevel = Ask + TakeProfit * Point; else TakeProfitLevel = 0.0;
         if(OrdersTotal() < MaxOpenTrade)
         Ticket = OrderSend(Symbol(), OP_BUY, Lots, Ask, Slippage, StopLossLevel, TakeProfitLevel, "Buy(#" + MagicNumber + ")", MagicNumber, 0, DodgerBlue);
         if(Ticket > 0) {
            if (OrderSelect(Ticket, SELECT_BY_TICKET, MODE_TRADES)) {
				Print("BUY order opened : ", OrderOpenPrice());
                if (SignalMail) SendMail("[Signal Alert]", "[" + Symbol() + "] " + DoubleToStr(Ask, Digits) + " Open Buy");
			} else {
				Print("Error opening BUY order : ", GetLastError());
			}
         }
         if (EachTickMode) TickCheck = True;
         if (!EachTickMode) BarCount = Bars;
         return(0);
      }
   }

   //Sell
   if (Order == SIGNAL_SELL && ((EachTickMode && !TickCheck) || (!EachTickMode && (Bars != BarCount)))) {
      IsTrade = False;//---allows multiple orders to open
      if(!IsTrade) {
         //Check free margin
         if (AccountFreeMargin() < (1000 * Lots)) {
            Print("We have no money. Free Margin = ", AccountFreeMargin());
            return(0);
         }

         if (StopLossMode) StopLossLevel = Bid + StopLoss * Point; else StopLossLevel = 0.0;
         if (TakeProfitMode) TakeProfitLevel = Bid - TakeProfit * Point; else TakeProfitLevel = 0.0;
         if(OrdersTotal() < MaxOpenTrade)
         Ticket = OrderSend(Symbol(), OP_SELL, Lots, Bid, Slippage, StopLossLevel, TakeProfitLevel, "Sell(#" + MagicNumber + ")", MagicNumber, 0, DeepPink);
         if(Ticket > 0) {
            if (OrderSelect(Ticket, SELECT_BY_TICKET, MODE_TRADES)) {
				Print("SELL order opened : ", OrderOpenPrice());
                if (SignalMail) SendMail("[Signal Alert]", "[" + Symbol() + "] " + DoubleToStr(Bid, Digits) + " Open Sell");
			} else {
				Print("Error opening SELL order : ", GetLastError());
			}
         }
         if (EachTickMode) TickCheck = True;
         if (!EachTickMode) BarCount = Bars;
         return(0);
      }
   }

   if (!EachTickMode) BarCount = Bars;

   return(0);
}

//+----------------------------------------------------------------------------+
//|                                "Functions For Holiday Safety Features.mql" |
//|                                             Property Copyright "Eaglehawk" |
//|            Property Link "http://www.forex-tsd.com/members/Eaglehawk.html" |
//+----------------------------------------------------------------------------+


//determines whether to get out or add a trailing stop, and if to get out when

int timedclosingtest(int Order)
 {
   double CurrentClose = iClose(NULL, 0, 1);
   double TrendClose = iClose(NULL, 0, 3);

   
   {
    HolidayAbandonTest();
    HolidayTest();
   }

      if (OrderType()==OP_BUY && DayOff == True && Ask<OrderOpenPrice() && CurrentClose > TrendClose )
         {
          TrailingStopMode = True;
         }

      if (OrderType()==OP_BUY && DayOff == True && Ask<OrderOpenPrice() && CurrentClose < TrendClose )
         {
          Order = SIGNAL_CLOSEBUY;
         }


      if (OrderType()==OP_SELL && DayOff == True && OrderOpenPrice()>Bid  && CurrentClose < TrendClose )
         {
          TrailingStopMode = True;
         }
   
      if (OrderType()==OP_SELL && DayOff == True && OrderOpenPrice()>Bid  && CurrentClose > TrendClose ) 
         {
          Order = SIGNAL_CLOSESELL;
         }


      if (OrderType()==OP_SELL && DayOffClose == True)
         {
          Order = SIGNAL_CLOSESELL;
         }

      if (OrderType()==OP_BUY && DayOffClose == True)
         {
          Order = SIGNAL_CLOSEBUY;
         }
   
      
      if (OrderType()==OP_SELL && DayOff == True && OrderOpenPrice()-Bid >0)
         {
          TrailingStopMode = True;
         }
      
      if (OrderType()==OP_BUY && DayOff == True && Ask-OrderOpenPrice() >0)
         {
          TrailingStopMode = True;
         }

   return(Order);
 }


/*Holidays for Interbankfx

New Years Day                 January 1

Martin Luther King Jr. Day    January 20

Washington's Birthday         February 17

Good Friday                   Friday before Easter

Memorial Day                  May 26

Independence Day              July 4

Labor Day                     September 1

Thanksgiving Day              Fourth Thurday of November

Christmas                     December 25*/



int goodfriday(int gmonth, int gday)
 {
      double cycledays = 29.5306;//approxamation of how long it takes the moon to return to a full moon
      int month = 11;//last full moon was november 2006
      double day = 5;//last full moon was november 5, 2006
      bool FullMoon = False;//self-explanatory
      gmonth = 0;//month good friday occurs in
      gday = 0;//day of the month good friday occurs
      int Mday = 0;//number of days in february, determined below
      double day2 = 0;//value used to seperate the decimal from the day's value
      int day3 = 0;//day withought decimals
       {

         //beginning time of the full moon
         //Month() = month && Day() = day && Year() = 2006 && FullMoon = True;
         
         // cycles through the days to determine the next full move
         if (Month() == month && Day() == day + cycledays && Year() == 2006)
          {
           FullMoon = True;
          }

         //continues the cycle for the months with 31 days in them
         if ((Month() == 1 || Month() == 3 || Month() == 5 || Month() == 7 || Month() == 8 || Month() == 10 || Month() == 12) && day + cycledays > 31)
         {
          month++;
          day = day + cycledays - 31;
         }

         //continues the cycle for the months with 30 days in them
         if ((Month() == 4 || Month() == 6 || Month() == 9 || Month() == 11) && day + cycledays > 30)
         {
          month++;
          day = day + cycledays - 30;
         }

         //resets the months after december is over
         if (month > 12)
         {
          month = 1;
         }

         //expression determines if we are in a leap year to determine whether there are 28 or 29 days in february
         if (Month() == 2)
           {if ((MathMod(Year(),4) == 0) && (((MathMod(Year(),100) == 0) && (MathMod(Year(),400) == 0)) || (MathMod(Year(),100) != 0))) Mday = 29; else Mday = 28;}

         //resets the days after february finishes
         if (Month() == 2 && day + cycledays > Mday)
          {
           month++;
           day = day + cycledays - Mday;
          }

         //determines what difference is required to round the day count down to an integer
         {day2 = (NormalizeDouble(day,0) - NormalizeDouble(day,4));}

         //expression rounds the day value down to an integer
         if (MathRound(day2) == 1)
          {
          day3 = day - day2;
          }
         //determines exact day of full moon 
         while((day3 == Day()) && (month == Month()))
          {
           FullMoon = True;
           gmonth = day3;
           gday = month;
          }
         return(0);
       }
 }


//function starts off the counting for the safety feature 2 days before the holiday

bool HolidayTest()
 {
   int gmonth, gday;
   {
    goodfriday(gmonth, gday);
   }
      DayOff = False; // when we get close to when interbankfx takes the day off

      if ( Month() == 12 && Day() >= 30 || Month() == 1 && Day() <= 1 ) //New Years Day
         {
          DayOff = True;
         }
    
      if (Month() == 1 && (Day() >= 18 && Day() <= 20)) //Martin Luther King Jr. Day
         {
         DayOff = True;
         }
   
      if (Month() == 2 && (Day() >= 15 && Day() <= 17)) //Washington's Birthday
         {
         DayOff = True;
         }
   
      if (Month() == gmonth && (Day() <= gday - 2 && Day() >= gday - 4)) //Good Friday
         {
         DayOff = True;
         }
   
      if (Month() == 5 && (Day() >= 24 && Day() <= 26)) //Memorial Day
         {
         DayOff = True;
         }
   
      if (Month() == 7 && (Day() >= 2 && Day() <= 4)) //Independece Day
         {
         DayOff = True;
         }

      if ( Month() == 8 && Day() >= 30 || Month() == 9 && Day()== 1 ) //Labor Day
         {
         DayOff = True;
         }

      if (Month() == 11 && (DayOfWeek() >= 3 && DayOfWeek() <=6)  && Day() >=21) //Thanksgiving Day
         {
         DayOff = True;
         }
   
      if (Month() == 12 && (Day() >= 23 && Day() <= 25)) //Christmas Day
         {
         DayOff = True;
         }
 }
//sets the time to abandon all trades, (9:00 P.M. the night before the holiday)
bool HolidayAbandonTest()
 {
   int gmonth, gday;
   {
   goodfriday(gmonth, gday);
   }
      DayOffClose = false;//abandons trades
   
      if (Month() == 12 && Day() == 31 && Hour() == 21) //New Years Day
         {
         DayOffClose = True;
         }

      if (Month() == 1 && (Day() == 19 && Hour() <= 21)) //Martin Luther King Jr. Day
         {
         DayOffClose = True;
         }

      if (Month() == 2 && Day() == 16 && Hour() == 21) //Washington's Birthday
         {
         DayOffClose = True;
         }

      if (Month() == gmonth && Day() == gday - 1 && Hour() == 21) //Good Friday
         {
         DayOffClose = True;
         }

      if (Month() == 5 && Day() == 25 && Hour() == 21) //Memorial Day
         {
         DayOffClose = True;
         }

      if (Month() == 7 && Day() == 3 && Hour() == 21) //Independece Day
         {
         DayOffClose = True;
         }
   
      if (Month() == 8 && Day()== 31 && Hour() == 21) //Labor Day
         {
         DayOffClose = True;
         }

      if (Month() == 11 && Day() >=21 && DayOfWeek() <=6) //Thanksgiving Day
         {
         DayOffClose = True;
         }
      if (Month() == 12 && Day() == 24 && Hour() == 21) //Christmas Day
         {
          DayOffClose = True;
         }
 }   

//+------------------------------------------------------------------------------------------------------------------------------------------------+